// Bibliotheken zum Einbinden (Zufallszahlen, Ein-Ausgabe)
#include <cstdlib>
#include <stdio.h>
#include <iostream>
#include "hilf.h"
#include "vector.h"
#include "vector2.h"
#include "LGSdirekt.h"
#include "densematrix.h"

using namespace std;

// Das Hauptprogramm
int main()
{ 
  int i,n;
  double* b;
  double* x;
  double* A;
  double* y;
  int pivot,d;
  double value,eps;
  char mat;
  cout <<"Beispiel: z- 2x2 matrix,v-Vandermonde,h-Hilbertmatrix"<< endl;
  cin>> mat;
  cout <<"Pivotsuche (0/1)" <<endl;
  cin>> pivot;
  switch (mat)
    {
    case 'z':
      {
        n=2;
        b=(double*)malloc(n*sizeof(double)); 
	break;
      }
    case 'h':
      {
        cout <<"Groesse?:"<<endl;
        cin >> n;
        b=(double*)malloc(n*sizeof(double)); 
        break;
      }
    case 'v':
      {
       cout <<"Groesse?:"<<endl;
       cin >> n;
       b=(double*)malloc(n*sizeof(double));
       y=(double*)malloc(n*sizeof(double));   
       cout <<"Punkte?"<<endl;
       for (i=0;i<n;i++)
             {
        	  cin >> y[i];
             }
          cout <<"Werte?"<<endl;
          for (i=0;i<n;i++)
             {
        	  cin >> b[i];
             }  
      }
    }
   // Speicher allokieren
   A=(double*)malloc(n*n*sizeof(double)); 
   x=(double*)malloc(n*sizeof(double)); 
   switch (mat)
     {
     case 'z': zweimalzwei(A,b);break;
     case 'h': hilbert(A,b,n);break;
     case 'v': vandermonde(A,y,n);
     }
   cout<<"Matrix "<< n<<endl; 
   ausgabe(A,n*n);
   cout<<"Rechte Seite"<<endl;
   ausgabe(b,n);
   GaussDense(A,b,x,n,pivot);
   cout<<"Ergebnis"<<endl;
    ausgabe(x,n);
   if (mat=='h')
     {
      vdbmax(A,n*n,&value,&d);
      cout <<" Max in |A| "<< value <<endl;
      hilbert(A,b,n);
      y=(double*)malloc(n*sizeof(double));
      eps=pow(2,-32);
      vdaxpy(n,y,eps,b,y);
      GaussDense(A,y,x,n,pivot);
      ausgabe(y,n);
      cout<<"Gestoertes Resultat"<<endl; 
      ausgabe(x,n); 
     }
   free(x);
   if (mat!='z')
     {
      free(y);
      free(b);
     }
   free(A);
   return 0;
}
